package com.stormtales.notevault.data.dao;

import androidx.lifecycle.LiveData;
import androidx.room.*;
import com.stormtales.notevault.data.entities.NoteSheet;
import com.stormtales.notevault.data.entities.Song;
import com.stormtales.notevault.data.sync.SyncStatus;

import java.util.List;

@Dao
public interface SongDao {
    @Insert
    long insert(Song song);

    @Query("SELECT * FROM song WHERE syncStatus != 1")
    List<Song> getAllSongs();

    @Update
    void update(Song song);

    @Insert
    void insert(List<NoteSheet> noteSheets);

    @Delete
    void deleteNoteSheets(List<NoteSheet> noteSheets);

    @Query("SELECT * FROM NoteSheet WHERE songID = :songID")
    List<NoteSheet> getNoteSheetsBySong(int songID);

    @Query("SELECT localFileName FROM NoteSheet WHERE songID = :songID")
    List<String> getNoteSheetFilesBySongID(int songID);

    @Query("SELECT * FROM Song WHERE syncStatus = :syncStatus")
    List<Song> getSongsBySyncStatus(SyncStatus syncStatus);

    @Update
    void updateSongs(List<Song> songs);

    @Query("SELECT * FROM Song WHERE localID IN (:localIDs)")
    List<Song> getSongsByLocalIDs(List<Integer> localIDs);
}
