package com.stormtales.notevault.network.sync;

import android.content.Context;
import com.stormtales.notevault.data.entities.Song;
import com.stormtales.notevault.data.repositories.SongRepository;
import com.stormtales.notevault.data.repositories.SongSyncRepository;
import com.stormtales.notevault.network.sync.models.BatchCreateResponse;
import com.stormtales.notevault.ui.gallery.GalleryViewModel;

import java.util.List;

public class SongSyncModule {
    private SongRepository songRepository;
    private SongSyncRepository songSyncRepository;
    private SongSyncService songSyncService;
    private GalleryViewModel syncViewModel;

    public SongSyncModule(Context context, GalleryViewModel syncViewModel) {
        this.songRepository = new SongRepository(context);
        this.songSyncRepository = new SongSyncRepository(context);
        this.songSyncService = new SongSyncService(context);
        this.syncViewModel = syncViewModel;
    }

    public void syncCreatedSongs(FinishSongSyncingCallback callback) {
        songSyncRepository.loadCreatedSongs(result -> {
            songSyncService.syncCreatedSongs(result, new FinishSongSyncingCallback() {
                @Override
                public void finishSongSyncing(BatchCreateResponse response) {
                    songSyncRepository.markCreatedSongsAsSynced(response);
                    callback.finishSongSyncing(response);
                }
            });
        });
    }

    public interface FinishSongSyncingCallback {
        void finishSongSyncing(BatchCreateResponse response);
    }
}
