package com.stormtales.notevault.network.sync.models;

import com.stormtales.notevault.data.entities.Song;

public class SongCreateRequest {
    private int localID;
    private String title;
    private String composer;
    private String genre;
    private int year;

    public SongCreateRequest(int localID, String title, String composer, String genre, int year) {
        this.localID = localID;
        this.title = title;
        this.composer = composer;
        this.genre = genre;
        this.year = year;
    }

    public SongCreateRequest(Song song) {
        this.localID = song.getLocalID();
        this.title = song.getTitle();
        this.composer = song.getComposer();
        this.genre = song.getGenre();
        this.year = song.getYear();
    }

    public int getLocalID() {
        return localID;
    }

    public void setLocalID(int localID) {
        this.localID = localID;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getComposer() {
        return composer;
    }

    public void setComposer(String composer) {
        this.composer = composer;
    }

    public String getGenre() {
        return genre;
    }

    public void setGenre(String genre) {
        this.genre = genre;
    }

    public int getYear() {
        return year;
    }

    public void setYear(int year) {
        this.year = year;
    }
}
