package com.stormtales.notevault.ui.gallery;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;
import com.stormtales.notevault.data.repositories.SongRepository;
import com.stormtales.notevault.network.sync.SongSyncModule;

public class GalleryViewModel extends ViewModel {

    private final MutableLiveData<Boolean> isCreatedSongSyncing;
    private SongSyncModule songSyncModule;

    public GalleryViewModel() {

        isCreatedSongSyncing = new MutableLiveData<>();
        isCreatedSongSyncing.setValue(false);
    }

    public MutableLiveData<Boolean> getIsCreatedSongSyncing() {
        return isCreatedSongSyncing;
    }

    public void startCreateSongSyncing() {
        if(this.songSyncModule == null) throw new RuntimeException("SongSyncModule is not initialized");
        this.isCreatedSongSyncing.setValue(true);

        this.songSyncModule.syncCreatedSongs(batchResponse -> {
            this.isCreatedSongSyncing.setValue(false);
        });
    }

    public void setSongSyncModule(SongSyncModule songSyncModule) {
        this.songSyncModule = songSyncModule;
    }
}