package com.stormtales.notevault.ui.sheetdisplay;

import android.content.Intent;
import android.os.Bundle;
import androidx.appcompat.app.AppCompatActivity;
import androidx.viewpager2.widget.ViewPager2;
import com.google.android.material.tabs.TabLayout;
import com.google.android.material.tabs.TabLayoutMediator;
import com.stormtales.notevault.R;

import java.util.Arrays;
import java.util.List;

public class NoteSheetDisplayActivity extends AppCompatActivity {
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_note_sheet_viewer); // Erstelle eine Layout-Datei

        ViewPager2 imageView = findViewById(R.id.viewPager); // Angenommen, du hast ein ImageView
        TabLayout tabLayout = findViewById(R.id.tabLayout);



        // Die URI aus dem Intent erhalten
        Intent intent = getIntent();
        String[] imageUris = intent.getStringArrayExtra("imageUris");
        if (imageUris != null) {
            List<String> uriList = Arrays.asList(imageUris);
            ImagePagerAdapter adapter = new ImagePagerAdapter(this, uriList);
            imageView.setAdapter(adapter); // Setze die URI in das ImageView

            new TabLayoutMediator(tabLayout, imageView,
                    (tab, position) -> tab.setText("Sheet " + (position + 1)) // Hier kannst du auch andere Labels verwenden
            ).attach();
        } else {
            throw new NullPointerException();
        }
    }
}
